{-
The Simplest Math Problem No One Can Solve - Collatz Conjecture
https://youtu.be/094y1Z2wpJg
-}

import           Control.Monad ()
import           Debug.Trace   (trace)

f' :: Integer -> Integer
f' n = f'' 0 n
  where
    f'' :: Integer -> Integer -> Integer
    f'' i n'
      | n' == 1 = t' i
      | even n' = t $ f'' (succ i) (n' `div` 2)
      | odd  n' = t $ f'' (succ i) (3*n' + 1)
      where t   = trace ("i: " ++ show i ++ ", number: " ++ show n')
            t'  = t'' $ trace ("END: " ++ show n ++ ", length: " <> show i) t''
            t'' = trace "\n#######################################################\n"

f :: Integer -> Integer
f n = s 0 n
  where
    s :: Integer -> Integer -> Integer
    s i n
      | n == 1 = i
      | even n = s i' (n `div` 2)
      | odd  n = s i' (3*n + 1)
      where i' = succ i

main :: IO ()
main = print $ map f [2^361..]

-- collatz collect
-- generate the collatz sequence and return it

cc :: Integer -> [Integer]
cc n = cc' [] n
  where
    cc' :: [Integer] -> Integer -> [Integer]
    cc' acc n
      | n == 1 = 1:acc
      | even n = cc' acc' (n `div` 2)
      | odd  n = cc' acc' (3*n + 1)
      where acc' = acc <> [n]

primes :: [Integer]
primes = sieve [2..]
  where
    sieve (p:xs) = p : sieve [x|x <- xs, x `mod` p > 0]

isPrime k = (k > 1) && null [ x | x <- [2..k - 1], k `mod` x == 0]
